// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:architecture_example/domain/entities/album.dart';
import 'package:architecture_example/domain/entities/photo.dart';
import 'package:wyatt_architecture/wyatt_architecture.dart';

abstract class PhotoRepository extends BaseRepository {
  FutureResult<Album> getAlbum(int id);
  FutureResult<List<Album>> getAllAlbums({int? start, int? limit});
  FutureResult<Photo> getPhoto(int id);
  FutureResult<List<Photo>> getAllPhotos({int? start, int? limit});
  FutureResult<List<Photo>> getPhotosFromAlbum(
    int albumId, {
    int? start,
    int? limit,
  });
  FutureResult<void> addPhotoToFavorites(Photo photo);
  FutureResult<void> deletePhotoFromFavorites(int id);
  FutureResult<List<Photo>> getAllPhotosFromFavorites();
  FutureResult<bool> checkIfPhotoIsInFavorites(int id);
}
